/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const Je=require("react"),n=require("prop-types"),r=require("@progress/kendo-react-common"),Qe=require("@progress/kendo-react-popup"),Xe=require("@progress/kendo-react-intl"),xe=require("@progress/kendo-react-treeview"),Ye=require("../package-metadata.js"),G=require("../common/utils.js"),Ze=require("./useDropdownWidth.js"),et=require("./ListNoData.js"),h=require("../messages/index.js"),tt=require("@progress/kendo-react-labels"),De=require("../common/ListFilter.js"),nt=require("@progress/kendo-react-buttons"),Fe=require("@progress/kendo-svg-icons"),at=require("../common/AdaptiveMode.js"),ot=require("@progress/kendo-react-layout");function rt(u){const f=Object.create(null,{[Symbol.toStringTag]:{value:"Module"}});if(u){for(const s in u)if(s!=="default"){const o=Object.getOwnPropertyDescriptor(u,s);Object.defineProperty(f,s,o.get?o:{enumerable:!0,get:()=>u[s]})}}return f.default=u,Object.freeze(f)}const t=rt(Je),{sizeMap:st,roundedMap:it}=r.kendoThemeMaps,lt="Please select a value from the list!",ct=u=>t.createElement("span",{className:"k-input-value-text"},u.children),Ie=u=>u.split("_").map(f=>parseInt(f,10)),ut=(u,f)=>{const{validationMessage:s,valid:o,required:U}=u;return{customError:s!==void 0,valid:!!(o!==void 0?o:!U||f),valueMissing:!f}},oe={selectField:"selected",subItemsField:"items",popupSettings:{animate:!0,width:"200px",height:"200px"},data:[],required:!1,style:{},validityStyles:!0,size:"medium",rounded:"medium",fillMode:"solid"},Se=r.createPropsContext(),re=t.forwardRef((u,f)=>{r.validatePackage(Ye.packageMetadata);const s=r.usePropsContext(Se,u),o={...oe,...s},U=r.useId(),se=o.id||U,{data:M,dataItemKey:T,popupSettings:k={},style:P,opened:d,disabled:S,onOpen:N=r.noop,onClose:v=r.noop,placeholder:J,label:O,name:Re,selectField:H,subItemsField:V,validationMessage:j,valid:qe,required:Q,validityStyles:Ke}=o,X=r.getTabIndex(o.tabIndex,S),i=t.useRef(null),g=t.useRef(null),R=t.useRef(null),Y=t.useRef(null),_=t.useRef(null),C=t.useRef(null),$=t.useRef(!1),[ie,Me]=t.useState(void 0),w=o.value!==void 0,b=w?o.value:ie!==void 0?ie:o.defaultValue,L=G.isPresent(b),Z=L?G.getItemValue(b,o.textField):"",ee=ut({validationMessage:j,valid:qe,required:Q},L),Te=t.useCallback(()=>g.current&&g.current.focus(),[]);t.useImperativeHandle(i,()=>({props:o,element:g.current,focus:Te})),t.useImperativeHandle(f,()=>i.current);const x=r.useRtl(g,o.dir),Pe={width:Ze.useDropdownWidth(g,oe,{...oe.popupSettings,...k},P),...x!==void 0?{direction:x}:{}},[Ne,le]=t.useState(!1),l=d!==void 0?d:Ne,[p,te]=t.useState(!1),[ne,Oe]=t.useState(),[ce,Ve]=t.useState(""),ue=r.useAdaptiveModeContext(),D=!!(ne&&ue&&ne<=ue.medium&&o.adaptive),Le=t.useCallback(()=>{_.current&&_.current.setCustomValidity&&_.current.setCustomValidity(ee.valid?"":j===void 0?lt:j)},[j,ee]);t.useEffect(Le),t.useEffect(()=>{const e=r.canUseDOM&&window.ResizeObserver&&new window.ResizeObserver(Ge.bind(void 0));return document!=null&&document.body&&e&&e.observe(document.body),()=>{document!=null&&document.body&&e&&e.disconnect()}},[]);const de=t.useCallback(e=>{if(!l){if(N){const a={...e};N.call(void 0,a)}d===void 0&&le(!0)}},[l,d,N]),F=t.useCallback(e=>{if(l){if(v){const a={...e};v.call(void 0,a)}d===void 0&&(le(!1),D&&setTimeout(()=>{var a;y((a=Y.current)==null?void 0:a.element)},300))}},[l,d,v,D]),We=t.useCallback(e=>{if(!e.isDefaultPrevented()&&i.current){te(!0);const a={syntheticEvent:e,nativeEvent:e.nativeEvent,target:i.current};(l?F:de)(a)}},[l,d,N,v]),q=t.useCallback(e=>{$.current=!0,e(),window.setTimeout(()=>$.current=!1,0)},[]),Be=t.useCallback(e=>{var I,Ee;const{keyCode:a,altKey:c}=e,m=C.current&&C.current.element;if(!i.current||e.isDefaultPrevented()&&((I=R.current)==null?void 0:I.element)===e.target)return;const K={syntheticEvent:e,nativeEvent:e.nativeEvent,target:i.current};if(l)if(a===r.Keys.esc||c&&a===r.Keys.up)e.preventDefault(),F(K);else if(m&&m.querySelector(".k-focus")&&(a===r.Keys.up||a===r.Keys.down||a===r.Keys.left||a===r.Keys.right||a===r.Keys.home||a===r.Keys.end)){if(a===r.Keys.up&&((Ee=R.current)!=null&&Ee.element)){const A=Array.from(m.querySelectorAll(".k-treeview-item")),we=[...A].reverse().find(z=>!!(z&&z.querySelector(".k-focus")));if(we&&A.indexOf(we)===0)return q(()=>{var z;y((z=R.current)==null?void 0:z.element)})}q(r.noop)}else a===r.Keys.down&&q(()=>{var A;y(((A=R.current)==null?void 0:A.element)||m)});else c&&a===r.Keys.down?(e.preventDefault(),de(K)):l||a===r.Keys.esc&&ve(e)},[l,d,N,v]),pe=t.useCallback(e=>{const{keyCode:a,altKey:c}=e;c||a!==r.Keys.up&&a!==r.Keys.down||(e.preventDefault(),q(a===r.Keys.up?()=>{y(g.current)}:()=>{y(C.current&&C.current.element)}))},[]),y=t.useCallback(e=>{e&&q(()=>e.focus())},[]),Ae=t.useCallback(()=>{var e;!p&&l&&!d?F({target:i.current}):s.filterable?y((e=R.current)==null?void 0:e.element):y(C.current&&C.current.element)},[v,s.filterable,p,d,l]),ze=t.useCallback(()=>{p&&y(g.current)},[p]),He=t.useCallback(e=>{if(!p&&!$.current&&(te(!0),s.onFocus&&i.current)){const a={syntheticEvent:e,nativeEvent:e.nativeEvent,target:i.current};s.onFocus.call(void 0,a)}},[p,s.onFocus]),je=t.useCallback(e=>{if(p&&!$.current&&i.current){te(!1);const a={syntheticEvent:e,nativeEvent:e.nativeEvent,target:i.current};if(s.onBlur){const c={...a};s.onBlur.call(void 0,c)}D||F(a)}},[p,s.onBlur,l,d,v]),_e=t.useCallback(()=>{p&&q(r.noop),D&&setTimeout(()=>{var e;y((e=Y.current)==null?void 0:e.element)},300)},[p,D]),fe=t.useCallback((e,a,c)=>{if(s.onChange){const m={value:a,level:c?Ie(c):[],...e};s.onChange.call(void 0,m)}w||Me(a)},[s.onChange,w]),me=t.useCallback(e=>{if(G.areSame(e.item,b,T)||!i.current)return;const{item:a,itemHierarchicalIndex:c,nativeEvent:m,syntheticEvent:K}=e,I={syntheticEvent:K,nativeEvent:m,target:i.current};fe(I,a,c),F(I)},[w,b,s.onChange,T,l,d,v]),ve=t.useCallback(e=>{if(!i.current)return;const a={syntheticEvent:e,nativeEvent:e.nativeEvent,target:i.current};fe(a,null),F(a),e.preventDefault()},[w,s.onChange,l,d,v]),ge=t.useCallback(e=>{if(e.syntheticEvent.stopPropagation(),s.onExpandChange&&i.current){const{item:a,itemHierarchicalIndex:c,nativeEvent:m,syntheticEvent:K}=e,I={level:Ie(c),item:a,nativeEvent:m,syntheticEvent:K,target:i.current};s.onExpandChange.call(void 0,I)}},[s.onExpandChange]),be=t.useCallback(e=>{if(s.onFilterChange&&i.current){const c={filter:{field:s.textField,operator:"contains",value:e.target.value},syntheticEvent:e.syntheticEvent,nativeEvent:e.nativeEvent,target:i.current};s.onFilterChange.call(void 0,c),s.filter===void 0&&Ve(e.target.value)}},[s.onFilterChange,s.filter,s.textField]),$e=()=>{const e=o.filterable?t.createElement(De,{value:o.filter===void 0?ce:o.filter,ref:Y,onChange:be,onKeyDown:pe,size:E,rounded:W,fillMode:B}):null,a={title:o.adaptiveTitle,expand:l,onClose:c=>F(c),windowWidth:ne,mobileFilter:e};return t.createElement(at.AdaptiveMode,{...a},t.createElement(ot.ActionSheetContent,{overflowHidden:!0},t.createElement("div",{className:"k-list-container"},t.createElement("div",{className:"k-list k-list-lg"},M.length>0?t.createElement(xe.TreeView,{ref:C,tabIndex:X,data:ye,focusIdField:T,textField:o.textField,selectField:H,expandField:o.expandField,childrenField:V,expandIcons:!0,onItemClick:me,onExpandChange:ge,size:E,item:o.item,dir:x,animate:k.animate}):t.createElement(he,null,ae.toLanguageString(h.nodata,h.messages[h.nodata]))))))},Ge=t.useCallback(e=>{for(const a of e)Oe(a.target.clientWidth)},[]),ye=t.useMemo(()=>w||!L?M:r.mapTree(M,V,e=>r.extendDataItem(e,V,{[H]:G.areSame(e,b,T)})),[M,b,w,L,H,V]),he=o.listNoData||et.ListNoData,Ue=o.valueHolder||ct,ae=Xe.useLocalization(),ke=!Ke||ee.valid,{size:E,rounded:W,fillMode:B}=o,Ce=t.createElement(t.Fragment,null,t.createElement("span",{className:r.classNames("k-dropdowntree k-picker",o.className,{[`k-picker-${st[E]||E}`]:E,[`k-rounded-${it[W]||W}`]:W,[`k-picker-${B}`]:B,"k-focus":p,"k-invalid":!ke,"k-loading":o.loading,"k-required":Q,"k-disabled":o.disabled}),tabIndex:X,accessKey:o.accessKey,id:se,style:O?{...P,width:void 0}:P,dir:x,ref:g,onKeyDown:S?void 0:Be,onMouseDown:_e,onClick:S?void 0:We,onFocus:He,onBlur:je,role:"combobox","aria-haspopup":"tree","aria-expanded":l,"aria-disabled":S,"aria-label":O,"aria-labelledby":o.ariaLabelledBy,"aria-describedby":o.ariaDescribedBy,"aria-required":Q},t.createElement("span",{className:"k-input-inner"},(Z||J)&&t.createElement(Ue,{item:b},Z||J)),o.loading&&t.createElement(r.IconWrap,{className:"k-input-loading-icon",name:"loading"}),L&&!S&&t.createElement("span",{onClick:ve,className:"k-clear-value",title:ae.toLanguageString(h.clear,h.messages[h.clear]),role:"button",tabIndex:-1,onMouseDown:e=>e.preventDefault()},t.createElement(r.IconWrap,{name:"x",icon:Fe.xIcon})),t.createElement(nt.Button,{tabIndex:-1,type:"button","aria-label":"select",className:"k-input-button",size:E,fillMode:B,themeColor:"base",rounded:null,icon:"caret-alt-down",svgIcon:Fe.caretAltDownIcon}),t.createElement("select",{name:Re,ref:_,tabIndex:-1,"aria-hidden":!0,title:O,style:{opacity:0,width:1,border:0,zIndex:-1,position:"absolute",left:"50%"}},t.createElement("option",{value:o.valueMap?o.valueMap.call(void 0,b):b})),!D&&t.createElement(Qe.Popup,{...k,className:r.classNames(k.className,{"k-rtl":x==="rtl"}),popupClass:r.classNames(k.popupClass,"k-dropdowntree-popup k-list-container"),style:Pe,anchor:k.anchor||g.current,show:l,onOpen:Ae,onClose:ze},o.filterable&&t.createElement(De,{value:o.filter===void 0?ce:o.filter,ref:R,onChange:be,onKeyDown:pe,size:E,rounded:W,fillMode:B,renderListFilterWrapper:!0,renderPrefixSeparator:!0}),M.length>0?t.createElement(xe.TreeView,{style:{height:k.height},ref:C,tabIndex:X,data:ye,focusIdField:T,textField:o.textField,selectField:H,expandField:o.expandField,childrenField:V,expandIcons:!0,onItemClick:me,onExpandChange:ge,size:E,item:o.item,dir:x,animate:k.animate}):t.createElement(he,null,ae.toLanguageString(h.nodata,h.messages[h.nodata])))),D&&$e());return O?t.createElement(tt.FloatingLabel,{label:O,editorValue:Z,editorPlaceholder:J,editorValid:ke,editorDisabled:S,editorId:se,style:{width:P?P.width:void 0},children:Ce,dir:x}):Ce}),dt={opened:n.bool,disabled:n.bool,dir:n.string,tabIndex:n.number,accessKey:n.string,data:n.array,value:n.any,valueMap:n.func,placeholder:n.string,dataItemKey:n.string.isRequired,textField:n.string.isRequired,selectField:n.string,expandField:n.string,subItemsField:n.string,className:n.string,style:n.object,label:n.string,validationMessage:n.string,validityStyles:n.bool,valid:n.bool,required:n.bool,name:n.string,id:n.string,ariaLabelledBy:n.string,ariaDescribedBy:n.string,filterable:n.bool,filter:n.string,loading:n.bool,popupSettings:n.shape({animate:n.oneOfType([n.bool,n.shape({openDuration:n.number,closeDuration:n.number})]),popupClass:n.string,className:n.string,appendTo:n.any,width:n.oneOfType([n.string,n.number]),height:n.oneOfType([n.string,n.number])}),onOpen:n.func,onClose:n.func,onFocus:n.func,onBlur:n.func,onChange:n.func,onFilterChange:n.func,onExpandChange:n.func,item:n.func,valueHolder:n.func,listNoData:n.func,adaptiveTitle:n.string,adaptive:n.bool};re.displayName="KendoReactDropDownTree";re.propTypes=dt;exports.DropDownTree=re;exports.DropDownTreePropsContext=Se;
